Dim RebuildAll
Dim Configuration
Dim ProjectPath
RebuildAll = False
For Iterator = 0 To Wscript.Arguments.Count - 1
    If StrComp(Left(Wscript.Arguments(Iterator), 8), "-Rebuild", vbTextCompare) = 0 Or StrComp(Wscript.Arguments(Iterator), "/Rebuild", vbTextCompare) = 0 Then
        RebuildAll = True
		If Mid(Wscript.Arguments(Iterator), 9, 1) = ":" Then
			Configuration = Right(Wscript.Arguments(Iterator), Len(Wscript.Arguments(Iterator)) - 9)
		End If
    ElseIf StrComp(Left(Wscript.Arguments(Iterator), 8), "-Build:", vbTextCompare) = 0 Or StrComp(Wscript.Arguments(Iterator), "/Build:", vbTextCompare) = 0 Then
		Configuration = Right(Wscript.Arguments(Iterator), Len(Wscript.Arguments(Iterator)) - 8)
	ElseIf ProjectPath = Empty Then
		ProjectPath = Wscript.Arguments(Iterator)
	Else
		MsgBox "Erro de parmetros!"
		Wscript.Quit(2)
    End If
Next

If ProjectPath = Empty Then
	MsgBox "Faltou especificar o projecto!"
	Wscript.Quit(1)
End If

Dim app
Set app = CreateObject("MSDev.Application")
app.Documents.Open ProjectPath

Dim TopLevelProject
Dim proj, projIterator
Set proj = app.ActiveProject
Set projIterator = proj
While projIterator <> Null And projIterator.Parent <> Null
    Set proj = projIterator
    Set projIterator = projIterator.Parent
Wend
Set TopLevelProject = proj

If (Configuration = Empty) Then
    Configuration = InputBox("Escolha a configurao que deseja compilar:", "Escolha a configurao que deseja compilar", app.ActiveConfiguration.Name)
	If Configuration = Empty Then
		app.Quit
		Wscript.Quit(1)
	End If
End If

Dim ConfigurationToUse
Set ConfigurationToUse = Nothing
If Configuration <> Empty Then
	Set configCol = TopLevelProject.Configurations
	numConfigs = configCol.Count
	For j = 1 To numConfigs
		Dim config
		Set config = configCol(j)
		If InStr(1, config.Name, Configuration, vbTextCompare) > 0 Then
			Dim Found
			Found = False
        
			If ConfigurationToUse Is Nothing Then
				Found = True
			End If
			If Not (ConfigurationToUse Is Nothing) Then
				If Len(config.Name) < Len(ConfigurationToUse.Name) Then
					Found = True
				End If
			End If
        
			If Found Then
				Set ConfigurationToUse = config
			End If
		End If
	Next
End If

If RebuildAll Then
	If ConfigurationToUse Is Nothing Then
		app.RebuildAll
	Else
	    app.RebuildAll ConfigurationToUse
	End If
Else
	If ConfigurationToUse Is Nothing Then
		app.Build
	Else
		app.Build ConfigurationToUse
	End If
End If
app.Quit
